' 
'  T H E   N E W   F R E E B A S I C
'                  8 - B I T   P A L E T T E   M A C H I N E
'- Version 1.1 for FB v0.12b or newer!
'
'(c)2005 Adigun Azikiwe Polack.  All Rights Reserved.


'
'Feel absolutely free to use this library for your projects in
'FreeBASIC.  If you do use ANY of these routines within this original
'library, then please give me credit for them, otherwise DO NOT EVEN
'USE THEM AT ALL, *period*.  Thank you so rather much for your honest
'patronage and cooperation!!  ;) !
'

' 
' C H A N G E L O G  
'
'
' v1.1 - Sunday, March 13, 2005
' 
'        Updated and improved the speed on my custom-emulated version
'        of the default 256-color GFXlib 2 palette, thereby causing
'        the supporting fading/rotation/negative/crossfade/greyscale
'        routines for that palette to have at least a bit of a 
'        noticable speed increase (thank you, VonGodric!!  ^_-=b )!!
'         
'
' v1.0 - Saturday, March 12, 2005
' 
'        Initial Release, FIRST presented on QBasicNews.com forums on
'        that very morning EST!!  ^-^ !
'
'


'First of all, BIGGEST Special Thanks go to Almighty Jehovah God for
'first inspiring me to do this one just to be a rather special
'blessing to the whole entire QB45/QB71/FB community and to YOU, the
'FreeBASIC (FB) programmer, too!!!  d=^-^=b !!

'I was looking to implement some *real* good custom palette fading/
'manipulation routines for the wildly AWESOME QB-like graphics library
'by Angelo Mottola entitled GFXlib 2 for FreeBASIC.  I tested several
'conversions of QB code sources based on fading in/out palettes and
'stuff, but they ended up failing so miserably due to either improper
'color fades and/or messed-up colors.  Then, lo and behold, somewhere
'on the internet, I discovered the QB source code by P. Bindels about
'his palette fading routines (BIG thanks go to him for his awesome
'coding ideas to me here!!), and I was _so_ inspired then with the
'idea to just go right ahead and code in my custom palette routines
'here for GFXlib 2 for FreeBASIC!!  So why not, hmmmm?  ;*)

'Also, BIG thanks go to Sterling Christensen for his awesome coding
'ideas on how to *actually* code a greyscale palette in FB as part of
'my original routines here, too!!

'Last (but CERTAINLY not even least), thanks also to Richard Eric M.
'Lope (aka Relsoft) and to Chris Chadwick for the PP256 palette
'loading code presented in this original FreeBASIC lib, and also to
'Steve Nunnally of Acid Works Software for the 768-byte palette
'loading code that was implemented in this very lib, too!!!

'The working .BI file that you are about to see has been
'custom-created by Adigun Azikiwe Polack.  HERE WE GO!!!  ^_-=b !   


'$inclib: "FBnewpal"

'
'  B L A C K   P A L E T T E   R O U T I N E S 
'
Declare Sub ZeroPal ()
Declare Sub ZeroPalRange (StartColor, EndColor)




'
'  S O L I D   C O L O R   P A L E T T E
'                                         R O U T I N E S 
'
Declare Sub SolidColorPal (R, G, B)
Declare Sub SolidColorPalRange (StartColor, EndColor, R, G, B)




'
'  P A L E T T E   F A D I N G / R O T A T I O N
'                                           R O U T I N E S 
'
'_____________________________________________________________________
' (For default 256-color GFXlib 2 palette only!)
'_____________________________________________________________________
Declare Sub FadeIn.DefaultPal (millisec)
Declare Sub FadeOut.DefaultPal (millisec)
Declare Sub FadeInX.DefaultPal (R.from, G.from, B.from, millisec)
Declare Sub FadeOutX.DefaultPal (R.to, G.to, B.to, millisec)
Declare Sub FadeInRange.DefaultPal (StartColor, EndColor, millisec)
Declare Sub FadeOutRange.DefaultPal (StartColor, EndColor, millisec)
Declare Sub FadeInRangeX.DefaultPal (StartColor, EndColor, R.from, G.from, B.from, millisec)
Declare Sub FadeOutRangeX.DefaultPal (StartColor, EndColor, R.to, G.to, B.to, millisec)
Declare Sub FadeCtrl.DefaultPal (FadeIn.Grade)
Declare Sub FadeCtrlX.DefaultPal (R.from, G.from, B.from, FadeIn.Grade)
Declare Sub FadeCtrlRangeX.DefaultPal (StartColor, EndColor, R.from, G.from, B.from, FadeIn.Grade)
Declare Sub PalRotate.DefaultPal (StartColor, EndColor, Rotate.Level)
Declare Sub PalRotateFC.DefaultPal (StartColor, EndColor, Rotate.Level, FadeIn.Grade)
Declare Sub PalRotateFCX.DefaultPal (StartColor, EndColor, R.from, G.from, B.from, Rotate.Level, FadeIn.Grade)
Declare Sub PalNeg.DefaultPal (Switch)
Declare Sub PalNegRange.DefaultPal (StartColor, EndColor, Switch)
Declare Sub PalNegRotate.DefaultPal (StartColor, EndColor, Rotate.Level)
Declare Sub PalFadeToNega.DefaultPal (millisec)
Declare Sub PalFadeFromNega.DefaultPal (millisec)
Declare Sub PalFadeRangeToNega.DefaultPal (StartColor, EndColor, millisec)
Declare Sub PalFadeRangeFromNega.DefaultPal (StartColor, EndColor, millisec)
Declare Sub PalNegaFadeCtrl.DefaultPal (FadeToNega.Grade)
Declare Sub PalNegaRangeFadeCtrl.DefaultPal (StartColor, EndColor, FadeToNega.Grade)
Declare Sub PalGreyScl.DefaultPal (Switch, NegaPalSwitch)
Declare Sub PalGreySclRange.DefaultPal (StartColor, EndColor, Switch, NegaPalSwitch)
Declare Sub PalGreySclRotate.DefaultPal (StartColor, EndColor, Rotate.Level, NegaPalSwitch)
Declare Sub PalFadeToGreyScl.DefaultPal (millisec, NegaPalSwitch)
Declare Sub PalFadeFromGreyScl.DefaultPal (millisec, NegaPalSwitch)
Declare Sub PalFadeRangeToGreyScl.DefaultPal (StartColor, EndColor, millisec, NegaPalSwitch)
Declare Sub PalFadeRangeFromGreyScl.DefaultPal (StartColor, EndColor, millisec, NegaPalSwitch)
Declare Sub PalGreyFadeCtrl.DefaultPal (FadeToGrey.Grade, NegaPalSwitch)
Declare Sub PalGreyRangeFadeCtrl.DefaultPal (StartColor, EndColor, FadeToGrey.Grade, NegaPalSwitch)


'_____________________________________________________________________
' (For custom 256-color palette files (.pal) with 768 bytes ONLY!)
'_____________________________________________________________________
Declare Sub FadeIn.768Pal (PalFile$, millisec)
Declare Sub FadeOut.768Pal (PalFile$, millisec)
Declare Sub FadeInX.768Pal (PalFile$, R.from, G.from, B.from, millisec)
Declare Sub FadeOutX.768Pal (PalFile$, R.to, G.to, B.to, millisec)
Declare Sub FadeInRange.768Pal (PalFile$, StartColor, EndColor, millisec)
Declare Sub FadeOutRange.768Pal (PalFile$, StartColor, EndColor, millisec)
Declare Sub FadeInRangeX.768Pal (PalFile$, StartColor, EndColor, R.from, G.from, B.from, millisec)
Declare Sub FadeOutRangeX.768Pal (PalFile$, StartColor, EndColor, R.to, G.to, B.to, millisec)
Declare Sub FadeCtrl.768Pal (PalFile$, FadeIn.Grade)
Declare Sub FadeCtrlX.768Pal (PalFile$, R.from, G.from, B.from, FadeIn.Grade)
Declare Sub FadeCtrlRangeX.768Pal (PalFile$, StartColor, EndColor, R.from, G.from, B.from, FadeIn.Grade)
Declare Sub PalRotate.768Pal (PalFile$, StartColor, EndColor, Rotate.Level)
Declare Sub PalRotateFC.768Pal (PalFile$, StartColor, EndColor, Rotate.Level, FadeIn.Grade)
Declare Sub PalRotateFCX.768Pal (PalFile$, StartColor, EndColor, R.from, G.from, B.from, Rotate.Level, FadeIn.Grade)
Declare Sub PalNeg.768Pal (PalFile$, Switch)
Declare Sub PalNegRange.768Pal (PalFile$, StartColor, EndColor, Switch)
Declare Sub PalNegRotate.768Pal (PalFile$, StartColor, EndColor, Rotate.Level)
Declare Sub PalFadeToNega.768Pal (PalFile$, millisec)
Declare Sub PalFadeFromNega.768Pal (PalFile$, millisec)
Declare Sub PalFadeRangeToNega.768Pal (PalFile$, StartColor, EndColor, millisec)
Declare Sub PalFadeRangeFromNega.768Pal (PalFile$, StartColor, EndColor, millisec)
Declare Sub PalNegaFadeCtrl.768Pal (PalFile$, FadeToNega.Grade)
Declare Sub PalNegaRangeFadeCtrl.768Pal (PalFile$, StartColor, EndColor, FadeToNega.Grade)
Declare Sub PalGreyScl.768Pal (PalFile$, Switch, NegaPalSwitch)
Declare Sub PalGreySclRange.768Pal (PalFile$, StartColor, EndColor, Switch, NegaPalSwitch)
Declare Sub PalGreySclRotate.768Pal (PalFile$, StartColor, EndColor, Rotate.Level, NegaPalSwitch)
Declare Sub PalFadeToGreyScl.768Pal (PalFile$, millisec, NegaPalSwitch)
Declare Sub PalFadeFromGreyScl.768Pal (PalFile$, millisec, NegaPalSwitch)
Declare Sub PalFadeRangeToGreyScl.768Pal (PalFile$, StartColor, EndColor, millisec, NegaPalSwitch)
Declare Sub PalFadeRangeFromGreyScl.768Pal (PalFile$, StartColor, EndColor, millisec, NegaPalSwitch)
Declare Sub PalGreyFadeCtrl.768Pal (PalFile$, FadeToGrey.Grade, NegaPalSwitch)
Declare Sub PalGreyRangeFadeCtrl.768Pal (PalFile$, StartColor, EndColor, FadeToGrey.Grade, NegaPalSwitch)


'_____________________________________________________________________
' (For custom PP256-based 256-color palette files (.pal) with 1,024
'  bytes ONLY!)
'_____________________________________________________________________
Declare Sub FadeIn.PP256 (PP256PalFile$, millisec)
Declare Sub FadeOut.PP256 (PP256PalFile$, millisec)
Declare Sub FadeInX.PP256 (PP256PalFile$, R.from, G.from, B.from, millisec)
Declare Sub FadeOutX.PP256 (PP256PalFile$, R.to, G.to, B.to, millisec)
Declare Sub FadeInRange.PP256 (PP256PalFile$, StartColor, EndColor, millisec)
Declare Sub FadeOutRange.PP256 (PP256PalFile$, StartColor, EndColor, millisec)
Declare Sub FadeInRangeX.PP256 (PP256PalFile$, StartColor, EndColor, R.from, G.from, B.from, millisec)
Declare Sub FadeOutRangeX.PP256 (PP256PalFile$, StartColor, EndColor, R.to, G.to, B.to, millisec)
Declare Sub FadeCtrl.PP256 (PP256PalFile$, FadeIn.Grade)
Declare Sub FadeCtrlX.PP256 (PP256PalFile$, R.from, G.from, B.from, FadeIn.Grade)
Declare Sub FadeCtrlRangeX.PP256 (PP256PalFile$, StartColor, EndColor, R.from, G.from, B.from, FadeIn.Grade)
Declare Sub PalRotate.PP256 (PP256PalFile$, StartColor, EndColor, Rotate.Level)
Declare Sub PalRotateFC.PP256 (PP256PalFile$, StartColor, EndColor, Rotate.Level, FadeIn.Grade)
Declare Sub PalRotateFCX.PP256 (PP256PalFile$, StartColor, EndColor, R.from, G.from, B.from, Rotate.Level, FadeIn.Grade)
Declare Sub PalNeg.PP256 (PP256PalFile$, Switch)
Declare Sub PalNegRange.PP256 (PP256PalFile$, StartColor, EndColor, Switch)
Declare Sub PalNegRotate.PP256 (PP256PalFile$, StartColor, EndColor, Rotate.Level)
Declare Sub PalFadeToNega.PP256 (PP256PalFile$, millisec)
Declare Sub PalFadeFromNega.PP256 (PP256PalFile$, millisec)
Declare Sub PalFadeRangeToNega.PP256 (PP256PalFile$, StartColor, EndColor, millisec)
Declare Sub PalFadeRangeFromNega.PP256 (PP256PalFile$, StartColor, EndColor, millisec)
Declare Sub PalNegaFadeCtrl.PP256 (PP256PalFile$, FadeToNega.Grade)
Declare Sub PalNegaRangeFadeCtrl.PP256 (PP256PalFile$, StartColor, EndColor, FadeToNega.Grade)
Declare Sub PalGreyScl.PP256 (PP256PalFile$, Switch, NegaPalSwitch)
Declare Sub PalGreySclRange.PP256 (PP256PalFile$, StartColor, EndColor, Switch, NegaPalSwitch)
Declare Sub PalGreySclRotate.PP256 (PP256PalFile$, StartColor, EndColor, Rotate.Level, NegaPalSwitch)
Declare Sub PalFadeToGreyScl.PP256 (PP256PalFile$, millisec, NegaPalSwitch)
Declare Sub PalFadeFromGreyScl.PP256 (PP256PalFile$, millisec, NegaPalSwitch)
Declare Sub PalFadeRangeToGreyScl.PP256 (PP256PalFile$, StartColor, EndColor, millisec, NegaPalSwitch)
Declare Sub PalFadeRangeFromGreyScl.PP256 (PP256PalFile$, StartColor, EndColor, millisec, NegaPalSwitch)
Declare Sub PalGreyFadeCtrl.PP256 (PP256PalFile$, FadeToGrey.Grade, NegaPalSwitch)
Declare Sub PalGreyRangeFadeCtrl.PP256 (PP256PalFile$, StartColor, EndColor, FadeToGrey.Grade, NegaPalSwitch)




'
'  P A L E T T E   C R O S S F A D I N G
'                                       R O U T I N E S 
'
'_____________________________________________________________________
' (For crossfading between default a 256-color GFXlib 2 palette *and*
'  a 256-color palette file (.pal) that has just 768 bytes ONLY!)
'_____________________________________________________________________
Declare Sub CrossFade.Default_to_768Pal (PalFile$, millisec)
Declare Sub CrossFade.768Pal_to_Default (PalFile$, millisec)
Declare Sub CrossFadeRange.Default_to_768Pal (StartColor, EndColor, PalFile$, millisec)
Declare Sub CrossFadeRange.768Pal_to_Default (StartColor, EndColor, PalFile$, millisec)
Declare Sub CrossFadeCtrl.Default_to_768Pal (FadeTo768Pal.Grade, PalFile$)
Declare Sub CrossFadeRangeCtrl.Default_to_768Pal (StartColor, EndColor, FadeTo768Pal.Grade, PalFile$)


'_____________________________________________________________________
' (For crossfading from one 768-byte 256-color palette file (.pal)
'  right into another one of the very same kind!!!  ^_^=b !)
'_____________________________________________________________________
Declare Sub CrossFade.768Pal_to_768Pal (PalFile.from$, PalFile.to$, millisec)
Declare Sub CrossFadeRange.768Pal_to_768Pal (StartColor, EndColor, PalFile.from$, PalFile.to$, millisec)
Declare Sub CrossFadeCtrl.768Pal_to_768Pal (FadeTo2nd768Pal.Grade, PalFile.from$, PalFile.to$)
Declare Sub CrossFadeRangeCtrl.768Pal_to_768Pal (StartColor, EndColor, FadeTo2nd768Pal.Grade, PalFile.from$, PalFile.to$)


'_____________________________________________________________________
' (For crossfading from one PP256-based 256-color palette file (.pal)
'  right into another one of the very same kind!!!  ^_^=b !)
'_____________________________________________________________________
Declare Sub CrossFade.PP256_to_PP256 (PP256PalFile.from$, PP256PalFile.to$, millisec)
Declare Sub CrossFadeRange.PP256_to_PP256 (StartColor, EndColor, PP256PalFile.from$, PP256PalFile.to$, millisec)
Declare Sub CrossFadeCtrl.PP256_to_PP256 (FadeTo2ndPP256Pal.Grade, PP256PalFile.from$, PP256PalFile.to$)
Declare Sub CrossFadeRangeCtrl.PP256_to_PP256 (StartColor, EndColor, FadeTo2ndPP256Pal.Grade, PP256PalFile.from$, PP256PalFile.to$)


'_____________________________________________________________________
' (For crossfading between a default 256-color GFXlib 2 palette *and*
'  a PP256-based 256-color palette file (.pal) that has just 1,024
'  bytes ONLY!)
'_____________________________________________________________________
Declare Sub CrossFade.Default_to_PP256 (PP256PalFile$, millisec)
Declare Sub CrossFade.PP256_to_Default (PP256PalFile$, millisec)
Declare Sub CrossFadeRange.Default_to_PP256 (StartColor, EndColor, PP256PalFile$, millisec)
Declare Sub CrossFadeRange.PP256_to_Default (StartColor, EndColor, PP256PalFile$, millisec)
Declare Sub CrossFadeCtrl.Default_to_PP256 (FadeToPP256Pal.Grade, PP256PalFile$)
Declare Sub CrossFadeRangeCtrl.Default_to_PP256 (StartColor, EndColor, FadeToPP256Pal.Grade, PP256PalFile$)


'_____________________________________________________________________
' (For crossfading between a 768-byte 256-color palette file (.pal)
'  and a PP256-based 256-color palette file (.pal) that has just 1,024
'  bytes ONLY!)
'_____________________________________________________________________
Declare Sub CrossFade.768Pal_to_PP256 (PalFile$, PP256PalFile$, millisec)
Declare Sub CrossFade.PP256_to_768Pal (PP256PalFile$, PalFile$, millisec)
Declare Sub CrossFadeRange.768Pal_to_PP256 (StartColor, EndColor, PalFile$, PP256PalFile$, millisec)
Declare Sub CrossFadeRange.PP256_to_768Pal (StartColor, EndColor, PP256PalFile$, PalFile$, millisec)
Declare Sub CrossFadeCtrl.768Pal_to_PP256 (FadeToPP256Pal.Grade, PalFile$, PP256PalFile$)
Declare Sub CrossFadeRangeCtrl.768Pal_to_PP256 (StartColor, EndColor, FadeToPP256Pal.Grade, PalFile$, PP256PalFile$)




'
'  C O L O R   A D J U S T   R O U T I N E 
'
Declare Sub WriteColor (Col, R, G, B)




'
'  7 6 8 - B Y T E   P A L E T T E   L O A D I N G
'                                             R O U T I N E 
'
'_____________________________________________________________________
' (The palette file to load here *MUST* be a 256-color palette that
'  has no more than 768 bytes only!)
'_____________________________________________________________________
Declare Sub LoadUp768Pal (PalFile$)




'
'  P P 2 5 6   P A L E T T E   L O A D I N G
'                                         R O U T I N E 
'
'_____________________________________________________________________
' (The palette file to load here *MUST* be a 256-color palette that is
'  PixelPlus 256 (or PP256)-based and has no more than 1,024 bytes!)
'_____________________________________________________________________
Declare Sub LoadUpPP256Pal (PP256PalFile$)




'
'  I M P O R T A N T   C O N S T A N T S   F O R
'               Y O U   T O   R E M E M B E R   H E R E ! ! 
'
CONST FBPM.True = 1, FBPM.False = 0 
CONST Yes = 1, No = 0
